 import java.awt.Graphics;
 import java.awt.Color;

 public class TRacer extends java.awt.Canvas implements Runnable
 {
   private short fPosition = 0;
   private String fName;
   static private final short kNumberOfSteps = 1000;
   TSuspendable fAncestor;

   public TRacer(String theName, TSuspendable theAncestor)
   {
     fName = new String(theName);
     fAncestor = theAncestor;
   }

   public TRacer(String theName)
   {
     fName = new String(theName);
     fAncestor = null;
   }

   public synchronized void paint(Graphics g)
   {
     g.setColor(Color.black);
     g.drawLine(0,getSize().height/2, getSize().width, getSize().height/2);
     g.setColor(Color.red);
     g.fillOval(fPosition*getSize().width/kNumberOfSteps, 0, 15, getSize().height);
   }
 
   public void run()
   {
     while (fPosition < kNumberOfSteps)
     {
       fPosition++;
       repaint();
       try
       {
         Thread.currentThread().sleep(10);
         if (fAncestor != null)
         {
           synchronized (fAncestor)
           {
             if (fAncestor.isSuspended())
               fAncestor.wait();
           }
         }
       } catch (InterruptedException e)
       {
         System.err.println("Thread " + fName + " interrupted.");
         System.exit(1);
       }
     }
     System.out.println("Thread " + fName + " has finished the race.");
   }

   public static void main(String argv[])
     {
       java.awt.Frame theFrame = new java.awt.Frame("One Racer");
       TRacer aRacer = new TRacer("Test");
       theFrame.setSize(400,200);
       theFrame.add(aRacer, java.awt.BorderLayout.CENTER);
       theFrame.show();
       aRacer.paint(theFrame.getGraphics());
       theFrame.pack();
       aRacer.run();
       System.exit(0);
     }
 }
