import java.awt.*;
import java.awt.event.*;

public class OKDialog extends Dialog {
  protected Button  fOKButton;
  protected static Frame  fFrame;

  public OKDialog( Frame theParent, String theMessage )
  {
    super( theParent, true );    // Call the parent's constructor

    // This Dialog box uses the GridBagLayout.
    GridBagLayout theGridBagLayout = new GridBagLayout();
    GridBagConstraints theConstraints = new GridBagConstraints();

    // Make the OK button and the message to display
    fOKButton = new Button( "OK" );
    Label aMessageLabel = new Label( theMessage );

    fOKButton.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        setVisible ( false );
        if (fFrame != null)
         fFrame.setVisible( false );
      }
    });

    setLayout( theGridBagLayout );

    // The message should not fill, it should be centered within this area, with
    // some extra padding.  The gridwidth of REMAINDER means this is the only
    // thing on its row, and the gridheight of RELATIVE means there should only
    // be one thing below it.
    theConstraints.fill = GridBagConstraints.NONE;
    theConstraints.anchor = GridBagConstraints.CENTER;
    theConstraints.ipadx = 20;
    theConstraints.ipady = 20;
    theConstraints.weightx = 1.0;
    theConstraints.weighty = 1.0;
    theConstraints.gridwidth = GridBagConstraints.REMAINDER;
    theConstraints.gridheight = GridBagConstraints.RELATIVE;
    theGridBagLayout.setConstraints( aMessageLabel, theConstraints );
    add( aMessageLabel );

    // The button has no padding, no weight, takes up minimal width, and
    // is the last thing in its column.
    theConstraints.ipadx = 0;
    theConstraints.ipady = 0;
    theConstraints.weightx = 0.0;
    theConstraints.weighty = 0.0;
    theConstraints.gridwidth = 1;
    theConstraints.gridheight = GridBagConstraints.REMAINDER;
    theGridBagLayout.setConstraints( fOKButton, theConstraints );
    add( fOKButton );

    // Pack is a special window method that makes the window take up the minimum
    // space necessary to contain its components.
    pack();
  }



  // Shortcut to make a frame automatically
  public static void makeOKDialog( String theDialogString ) {
    if ( fFrame == null )
      fFrame = new Frame( "Dialog" );
    OKDialog theOKDialog = new OKDialog( fFrame, theDialogString );

    // Shrink the frame to just fit the dialog
    fFrame.setSize( theOKDialog.getSize().width, theOKDialog.getSize().height );

    theOKDialog.show();
  }
}
