import java.awt.*;
 import java.applet.Applet;

 public class Animation2 extends Applet implements Runnable {
     int fFrame = -1;
     int fDelay;
     Thread fThread;
     Image[] fEarth;
     MediaTracker fTracker;
     Image fOffScreenImage;
     Graphics fOffScreenGraphics;
 
     public void init() {
       fEarth = new Image[30];
       String theString;
       int theFramesPerSecond = 10;
       fTracker = new MediaTracker( this );
       fOffScreenImage = createImage(getSize().width,
                                     getSize().height);
       fOffScreenGraphics = fOffScreenImage.getGraphics();

       // fill the offsceen buffer with blue
       fOffScreenGraphics.setColor(Color.blue);
       fOffScreenGraphics.fillRect(0, 0,
                      getSize().width, getSize().height);

       //load in the images
       for (int i=1; i<=30; i++)
       {
          fEarth[i-1] = getImage (getCodeBase(),
                                  "./Earth"+i+".gif");
          fTracker.addImage(fEarth[i-1], 0);
       }
 
       //How many milliseconds between frames?
       theString = getParameter("fps");
       try {
         if (theString != null) {
             theFramesPerSecond = Integer.parseInt(theString );
         }
       } catch (NumberFormatException e) {}
       fDelay = (theFramesPerSecond > 0) ?
                (1000 / theFramesPerSecond) : 100;
     }
 
     public void start() {
       // start a new thread for the animation
       if (fThread == null) {
           fThread = new Thread(this);
       }
       fThread.start();
     }

     public void stop() {
       // stop the animation thread
       fThread = null;
     }

     public void run() {
       // run at a low priority; animation is second-place to content
       Thread.currentThread().setPriority(Thread.MIN_PRIORITY);
       long theStartTime = System.currentTimeMillis();

       //Here comes the show.
       try {
        fTracker.waitForID(0);
       } catch (InterruptedException e) {
         System.err.println("Interrupted Exception: " + e.getMessage());
         e.printStackTrace();
         return;
       }
       while (Thread.currentThread() == fThread) {
 
         //Advance the frame.
         fFrame++;

         //Display it.
         repaint();

         //Delay depending on how far we are behind.
         try {
              theStartTime += fDelay;
              Thread.sleep(Math.max(0,
                                    theStartTime-
                           System.currentTimeMillis()));
         } catch (InterruptedException e) {
                  break;
         }
     }
   }

   public void update( Graphics g) {

       // fill the offsceen buffer with blue
       fOffScreenGraphics.setColor(Color.blue);
       fOffScreenGraphics.clearRect(0, 0,
                      getSize().width, getSize().height);
       fOffScreenGraphics.fillRect(0, 0,
                      getSize().width, getSize().height);
       paint(g);
   }

   //Draw the current frame
   public void paint(Graphics g) {
     if (fTracker.checkID( 0 )) {
       fOffScreenGraphics.drawImage(fEarth[fFrame % 30], 0, 0, this);
       g.drawImage(fOffScreenImage, 0, 0, this);
     }
   }
 }
